%**************************************************************************
%*
%* Copyright 2009 Arslan Shahid, UET, Lahore, PAKISTAN.
%* All rights reserved.
%* 
%* Redistribution and use in source and binary forms, with or without
%* modification,are permitted provided that the following conditions 
%* are met:
%*
%*    1. Redistributions of source code must retain the above copyright
%*       notice, this list of conditions and the following disclaimer.
%*
%*    2. Redistributions in binary form must reproduce the above copyright
%*       notice, this list of conditions and the following disclaimer in the
%*       documentation and/or other materials provided with the distribution.
%*
%* THIS FILE IS PROVIDED BY ARSLAN SHAHID ``AS IS'' AND ANY EXPRESS OR 
%* IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
%* OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
%* IN NO EVENT SHALL ARSLAN SHAHID OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
%* INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
%* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
%* SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
%* CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
%* LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY
%* WAY OUT OF THE USE OF THIS FILE, EVEN IF ADVISED OF THE POSSIBILITY
%* OF SUCH DAMAGE.
%* 
%*
%***************************************************************************** 
 
% Name:                diversity_analysis
% Author:              Arslan Shahid
% Date:                December 1, 2010
% Description:         Ebno(dB) Vs Ser plot

%*****************************************************************************

clc
clear all
Ns = 25;
n = 25;

Ebno_db = [-2.6:0.5:14];

fc=900e6;
M=16;
bit_rate=1000e6;

K=log2(M);

symbol_rate=bit_rate/K;
symbol_period=1/symbol_rate;


Nq=2*fc;

disp('Enter type of modulation:');
disp('1 for ASK')
disp('2 for PSK')
disp('3 for QAM')
disp('4 for FSK')
Modulation=input('');
sample_rate=10*Nq;

ser=zeros(1,length(Ebno_db));
ser_diversity=zeros(1,length(Ebno_db));

for exp=1:length(Ebno_db)
    Ebno=10^(Ebno_db(exp)/10);
    
    error=zeros(1,n);
    error_diversity=zeros(1,n);
    for trial=1:n
        error(trial)=performance_eval(fc,M,Ns,Ebno,Modulation);
        error_diversity(trial)=performance_eval_diversity(fc,M,Ns,Ebno,Modulation);
    end

avg_error=mean(error);
avg_error_diversity=mean(error_diversity);

ser(exp)=avg_error/Ns;
ser_diversity(exp)=avg_error_diversity/Ns;

end
figure

plot(Ebno_db,ser,'o');

hold on
plot(Ebno_db,ser_diversity,'k+')

title('Effect of diversity');
xlabel('SER --->');
ylabel('Ebno(dB) --->');

legend('without diversity', 'with diversity');