function [error]=performance_eval_diversity(fc,M,Ns,Ebno,modulation)


bit_rate=1000e6;

K=log2(M);
symbol_rate=bit_rate/K;
symbol_period=1/symbol_rate;

Nt=2;

Nq=2*fc;

sample_rate=10*Nq;

tss=1/sample_rate;
Nb=K*Ns;

tss=1/sample_rate;
Nb=K*Ns;

ns=sample_rate/symbol_rate;

final_time=(Ns*symbol_period)-tss;

symbol_time=[0:tss:symbol_period-tss];

time_vector=[0:tss:final_time];

data=bitgenerator(Nb);


symbolstream=bit2symbol(data,K);

symbolwave=upsampler(symbolstream,ns);

if(modulation==1)
    passbandwave=askmodulator(M,symbolstream,symbol_time,fc);
    len=length(symbolstream);
    temp=0;
    for k=1:len
        i=symbolstream(k)+1;
        Ac=2*i-1-M;
        temp=temp+((Ac^2)*symbol_period)/(2*K);
    end
    Eb=temp/len;
end

if(modulation==2)
    passbandwave=pskmodulator(M,symbolstream,symbol_time,fc);
    Ac=1;
    Eb=((Ac^2)*symbol_period)/(2*K);
end

if(modulation==3)
    passbandwave=qammodulator(M,symbolstream,symbol_time,fc);
    len=length(symbolstream);
    temp=0;
    for k=1:len
        M_new = sqrt(M);
        i=symbolstream(k)+1;
        Ac=i/M_new;
        temp=temp+((Ac^2)*symbol_period)/(2*K);
    end
    Eb=temp/len;
end

if(modulation==4)
    passbandwave=fskmodulator(M,symbolstream,symbol_time,symbol_period,fc);
    Ac=1;
    Eb=((Ac^2)*symbol_period)/(2*K);
end

No=Eb/Ebno;

noise11 =sqrt((No/2)*sample_rate)* randn(1,length(time_vector));
noise12 =sqrt((No/2)*sample_rate)* randn(1,length(time_vector));
noise21 =sqrt((No/2)*sample_rate)* randn(1,length(time_vector));
noise22 =sqrt((No/2)*sample_rate)* randn(1,length(time_vector));

received_signal1 = passbandwave + noise11 + passbandwave +noise21;
received_signal2 = passbandwave + noise12 + passbandwave +noise22;

[rec1 rec2]=estimation_generalized_diversity(received_signal1,received_signal2,time_vector,symbol_time,Ns,M,fc,K,symbol_period,modulation,Nt);

err=0;

for n=1:length(rec1)
    if(symbolwave(1,n)~=rec1(1,n))
        err=err+1;
    end
end

error=err/length(symbol_time);